#
# spec file for package lsh (Version 1.3.5)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  gmp gperf guile libz slib umb-scheme xdevel xf86 xshared
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim autoconf automake binutils cracklib gcc gdbm gettext gmp gperf guile libtool libz pam perl rpm slib umb-scheme xdevel xf86 xshared

Name:         lsh
Version:      1.3.5
Release:      188
%define oopver 0.8
License:      GPL
Group:        Productivity/Networking/SSH
#Provides:     
Autoreqprov:  on
Summary:      The GNU implementation of the secure shell protocol
Source:       ftp://ftp.gnupg.org/pub/gcrypt/lsh/lsh-%{version}.tar.gz
Source1:      ftp://ftp.gnupg.org/pub/gcrypt/lsh/lsh-%{version}.tar.gz.asc
#Source9:	ftp://ftp.gnupg.org/pub/gcrypt/contrib/idea.c
Source2:      rc.lshd
Source4:      sysconfig.lshd
Source11:     http://download.liboop.org/liboop-%{oopver}.tar.gz
Patch:        lsh-%{version}.diff
Patch6:       lsh-abort-on-alloc-fail.diff
URL:          http://www.gnupg.org/
Prefix:       /usr
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
Similar to openssh, this is a free implementation of the secure shell
protocol. The package consists of the lshd daemon accepting connections
to port 22 (ssh), the lsh client and tools for key management.

lsh is compiled without support for the IDEA algorithm required by
ssh1 clients. The reason is that IDEA is encumbered by patents, and may
only be used free of charge in certain non-commercial environments.

lsh however can be installed along with (open)ssh and supports fallback
to a opensshd resp. sshd1 daemon for such connections.

Docu can be found in /usr/share/doc/packages/lsh/
The startup of lshd is controlled by START_LSHD in rc.config.

Note: This package is still under development. If you want high security
and stability, better use openssh for now! lsh also misses PAM support.

Authors:
--------
    Niels Mller <nisse@lysator.liu.se>
    ... and many others.

SuSE series: sec

%prep
%setup -b11 
%patch -p1
%patch6 -p1
#cp -p $RPM_SOURCE_DIR/idea.c ${name}-%{version}/src
chown 0.0 -R *
%{?suse_update_config}

%build
cd ../liboop-%{oopver}
CFLAGS="$RPM_OPT_FLAGS" ./configure --disable-shared --prefix=/usr --mandir=%{_mandir} --infodir=%{_infodir} --sysconfdir=/etc --localstatedir=/var
make
# Note that we can only do this thanks to $RPM_BUILD_ROOT 
# so we can just ignore the liboop files later
make install DESTDIR=$PM_BUILD_ROOT
cd ../lsh-%{version}
CFLAGS="$RPM_OPT_FLAGS" ./configure --with-sshd1=/usr/sbin/sshd1 --prefix=/usr --mandir=%{_mandir} --infodir=%{_infodir} --sysconfdir=/etc --localstatedir=/var
make
make check

%install
make install DESTDIR=$RPM_BUILD_ROOT
install -o root -g root -m 0755 src/lcp $RPM_BUILD_ROOT/usr/bin/
install -d -o root -g root -m 0750 $RPM_BUILD_ROOT/etc/init.d/
install -d -o root -g root -m 0750 $RPM_BUILD_ROOT/var/adm/fillup-templates
install -o root -g root -m 750 $RPM_SOURCE_DIR/rc.lshd $RPM_BUILD_ROOT/etc/init.d/lshd
install -o root -g root -m 640 $RPM_SOURCE_DIR/sysconfig.lshd $RPM_BUILD_ROOT/var/adm/fillup-templates/
ln -sf ../../etc/init.d/lshd $RPM_BUILD_ROOT/usr/sbin/rclshd
# fixup
mv $RPM_BUILD_ROOT/%{_mandir}/man1/lsh_keygen.1 $RPM_BUILD_ROOT/%{_mandir}/man1/lsh-keygen.1
mv $RPM_BUILD_ROOT/%{_mandir}/man1/lsh_writekey.1 $RPM_BUILD_ROOT/%{_mandir}/man1/lsh-writekey.1

%files
/usr/bin/lsh
/usr/bin/lshg
/usr/bin/lsh-authorize
/usr/bin/lsh-decode-key
/usr/bin/lsh-export-key
/usr/bin/lsh-keygen
/usr/bin/lsh-writekey
/usr/bin/sexp-conv
/usr/bin/srp-gen
/usr/bin/ssh-conv
/usr/bin/sftp-server
/usr/bin/lcp
/usr/sbin/lshd
/usr/sbin/lsh_proxy
/usr/lib/libnettle.a
/usr/include/nettle
%{_infodir}/lsh.info.gz
%{_infodir}/nettle.info.gz
%{_mandir}/man1/lsh.1.gz
%{_mandir}/man1/lsh-keygen.1.gz
%{_mandir}/man1/lsh-writekey.1.gz
%{_mandir}/man5/DSA.5.gz
%{_mandir}/man5/SHA.5.gz
%{_mandir}/man5/SPKI.5.gz
%{_mandir}/man5/secsh.5.gz
%{_mandir}/man8/lshd.8.gz
%doc README NEWS COPYING ANNOUNCE AUTHORS FAQ distribution-key.gpg
%doc doc/NOTES doc/TASKLIST doc/TODO
#/usr/share/locale/*/LC_MESSAGES/lsh.mo
/etc/init.d/lshd
/usr/sbin/rclshd
/var/adm/fillup-templates/sysconfig.lshd

%post
# Create startup symlinks (LSB)
%{fillup_and_insserv -n -s lshd lshd START_LSHD}

%postun
%insserv_cleanup

%clean
test ! -z "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" && rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%changelog -n lsh
* Mon Sep 29 2003 - garloff@suse.de
- Add patch to properly deal with allocation failure. #31418.
  This potentially constitutes in a remotely exploitable
  vulnerability.
* Mon Jan 14 2002 - garloff@suse.de
- Add missing mpz_init calls to make_rsa_signer
- Add slib to build requirements
- Switch to new sysconfig handling
* Sat Jan 12 2002 - garloff@suse.de
- Include needed liboop and compile statically (for now)
- Install some more docu files
* Sat Jan 12 2002 - garloff@suse.de
- Update to lsh-1.3.5:
  * Fixed window change handling in lshd.
  * Replaced the io-backend code. Now uses liboop.
  * Uses nettle's implementations of cbc and des3 chaining.
* Fri Oct 26 2001 - garloff@suse.de
- Avoid triggering guile regeneration of .x file to fix build
  on iA64.
* Fri Oct 26 2001 - garloff@suse.de
- Compile fix for missing UINT64 decl (triggered on iA64).
* Thu Oct 11 2001 - ro@suse.de
- fix xauth.c to compile
* Tue Sep 11 2001 - garloff@suse.de
- Fix file list
- Fix init script (compliance with LSB)
* Mon Sep 10 2001 - garloff@suse.de
- Upgrades to lsh-1.3.4:
  * Suspend works
  * AES & SRP support improvements
  * X11 forwarding
- Upgrades to lsh-1.3.0:
  * Infrastructure changes
  * TSTP signal handling
- Upgrades to lsh-1.2: (1.1.1--1.2.0)
  * Gateway mode
  * CVS workarounds (avoid non-blocking mode for stdio fds)
  * encrypted private keys
  * RSA key support (incl. OpenSSH style)
  * scsh support
  * lcp (not installed by default)
  * Bugfixes & Cleanups
- Upgrades to lsh-1.1: (1.0.5--1.1.0)
  * Many new options
  * Many many bugfixes
  * Rijndael, Serpent algos
  * SPKI stuff
  * Kerberos support (experimental)
* Tue Sep 19 2000 - garloff@suse.de
- Upgrade to lsh-1.0.4
- Fixed manpage names (lsh-keygen, lsh-writekey)
* Sat Jul 08 2000 - garloff@suse.de
- Initial creation of lsh-1.0 package
- Added startup script and config via rc.config
- Use /usr/sbin/sshd as ssh1d path
